# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['AviatrixControllerGatewayKeepaliveConfigArgs', 'AviatrixControllerGatewayKeepaliveConfig']

@pulumi.input_type
class AviatrixControllerGatewayKeepaliveConfigArgs:
    def __init__(__self__, *,
                 keepalive_speed: pulumi.Input[str]):
        """
        The set of arguments for constructing a AviatrixControllerGatewayKeepaliveConfig resource.
        :param pulumi.Input[str] keepalive_speed: The gateway keepalive template name. Must be one of "slow", "medium" or "fast". Visit [here](https://docs.aviatrix.com/HowTos/gateway.html#gateway-keepalives) for the complete documentation about the gateway keepalive configuration.
        """
        pulumi.set(__self__, "keepalive_speed", keepalive_speed)

    @property
    @pulumi.getter(name="keepaliveSpeed")
    def keepalive_speed(self) -> pulumi.Input[str]:
        """
        The gateway keepalive template name. Must be one of "slow", "medium" or "fast". Visit [here](https://docs.aviatrix.com/HowTos/gateway.html#gateway-keepalives) for the complete documentation about the gateway keepalive configuration.
        """
        return pulumi.get(self, "keepalive_speed")

    @keepalive_speed.setter
    def keepalive_speed(self, value: pulumi.Input[str]):
        pulumi.set(self, "keepalive_speed", value)


@pulumi.input_type
class _AviatrixControllerGatewayKeepaliveConfigState:
    def __init__(__self__, *,
                 keepalive_speed: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering AviatrixControllerGatewayKeepaliveConfig resources.
        :param pulumi.Input[str] keepalive_speed: The gateway keepalive template name. Must be one of "slow", "medium" or "fast". Visit [here](https://docs.aviatrix.com/HowTos/gateway.html#gateway-keepalives) for the complete documentation about the gateway keepalive configuration.
        """
        if keepalive_speed is not None:
            pulumi.set(__self__, "keepalive_speed", keepalive_speed)

    @property
    @pulumi.getter(name="keepaliveSpeed")
    def keepalive_speed(self) -> Optional[pulumi.Input[str]]:
        """
        The gateway keepalive template name. Must be one of "slow", "medium" or "fast". Visit [here](https://docs.aviatrix.com/HowTos/gateway.html#gateway-keepalives) for the complete documentation about the gateway keepalive configuration.
        """
        return pulumi.get(self, "keepalive_speed")

    @keepalive_speed.setter
    def keepalive_speed(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "keepalive_speed", value)


class AviatrixControllerGatewayKeepaliveConfig(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 keepalive_speed: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        The **aviatrix_controller_gateway_keepalive_config** resource allows management of an Aviatrix Controller's gateway keepalive template configuration. This resource is available as of provider version R2.19.2+.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_aviatrix as aviatrix

        # Create an Aviatrix Controller Gateway Keepalive config
        test_gateway_keepalive = aviatrix.AviatrixControllerGatewayKeepaliveConfig("testGatewayKeepalive", keepalive_speed="medium")
        ```

        ## Import

        **aviatrix_controller_gateway_keepalive_config** can be imported using controller IP, e.g. controller IP is 10.11.12.13

        ```sh
         $ pulumi import aviatrix:index/aviatrixControllerGatewayKeepaliveConfig:AviatrixControllerGatewayKeepaliveConfig test_gateway_keepalive 10-11-12-13
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] keepalive_speed: The gateway keepalive template name. Must be one of "slow", "medium" or "fast". Visit [here](https://docs.aviatrix.com/HowTos/gateway.html#gateway-keepalives) for the complete documentation about the gateway keepalive configuration.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: AviatrixControllerGatewayKeepaliveConfigArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        The **aviatrix_controller_gateway_keepalive_config** resource allows management of an Aviatrix Controller's gateway keepalive template configuration. This resource is available as of provider version R2.19.2+.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_aviatrix as aviatrix

        # Create an Aviatrix Controller Gateway Keepalive config
        test_gateway_keepalive = aviatrix.AviatrixControllerGatewayKeepaliveConfig("testGatewayKeepalive", keepalive_speed="medium")
        ```

        ## Import

        **aviatrix_controller_gateway_keepalive_config** can be imported using controller IP, e.g. controller IP is 10.11.12.13

        ```sh
         $ pulumi import aviatrix:index/aviatrixControllerGatewayKeepaliveConfig:AviatrixControllerGatewayKeepaliveConfig test_gateway_keepalive 10-11-12-13
        ```

        :param str resource_name: The name of the resource.
        :param AviatrixControllerGatewayKeepaliveConfigArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(AviatrixControllerGatewayKeepaliveConfigArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 keepalive_speed: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = AviatrixControllerGatewayKeepaliveConfigArgs.__new__(AviatrixControllerGatewayKeepaliveConfigArgs)

            if keepalive_speed is None and not opts.urn:
                raise TypeError("Missing required property 'keepalive_speed'")
            __props__.__dict__["keepalive_speed"] = keepalive_speed
        super(AviatrixControllerGatewayKeepaliveConfig, __self__).__init__(
            'aviatrix:index/aviatrixControllerGatewayKeepaliveConfig:AviatrixControllerGatewayKeepaliveConfig',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            keepalive_speed: Optional[pulumi.Input[str]] = None) -> 'AviatrixControllerGatewayKeepaliveConfig':
        """
        Get an existing AviatrixControllerGatewayKeepaliveConfig resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] keepalive_speed: The gateway keepalive template name. Must be one of "slow", "medium" or "fast". Visit [here](https://docs.aviatrix.com/HowTos/gateway.html#gateway-keepalives) for the complete documentation about the gateway keepalive configuration.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _AviatrixControllerGatewayKeepaliveConfigState.__new__(_AviatrixControllerGatewayKeepaliveConfigState)

        __props__.__dict__["keepalive_speed"] = keepalive_speed
        return AviatrixControllerGatewayKeepaliveConfig(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="keepaliveSpeed")
    def keepalive_speed(self) -> pulumi.Output[str]:
        """
        The gateway keepalive template name. Must be one of "slow", "medium" or "fast". Visit [here](https://docs.aviatrix.com/HowTos/gateway.html#gateway-keepalives) for the complete documentation about the gateway keepalive configuration.
        """
        return pulumi.get(self, "keepalive_speed")

